/*
FILE : control_top.v
Build: 2011.08
Function: 16ֱӸCPLD16IOӣ£Ϊ0δΪ1.
ÿ10msɨһ16IOڣɨ16λݷΪη͵ڡ
ã1ʼλ16λݣ1ֹͣλʣ115200
ģʹ16λݷ
*/
module control_top(
			clk,
			key_in,
			rs232_tx_out
			);

input	clk;	//50MHZ ⲿԴʱ
//input	reset_n;	//λʱӣ͵ƽЧ

input	[15:0] key_in;	//ⲿ

output	rs232_tx_out;	//ڷ͹ܽ

////////////////////////////////////////////
//λʱģ
///////////////////////////////////////////
reg	[11:0] delay_count;
reg	reset_n;
always@(posedge clk )
		if(delay_count<=12'hffa)
			begin
			delay_count	<=	delay_count + 1'b1;
			reset_n	<=	1'b0;
			end
		else
			reset_n	<=	1'b1;
///////////////////////////////////////////
//50MHZ ʱӷƵ 5ms ģ
///////////////////////////////////////////
reg	[17:0] dive_count;
reg	clk_5ms;
always@(posedge clk or negedge reset_n)
if(!reset_n)
	begin
		dive_count	<=	18'h00000;
	end
else
	begin
	dive_count	<=	dive_count	+	1'b1;
	if( dive_count >= 18'h3D090 )
		begin
			clk_5ms	<=	~clk_5ms;
			dive_count	<=	18'h00000;
		end
	end
	
////////////////////////////////////////////////////////
//ȥë	
////////////////////////////////////////////////////////
reg [15:0]	key_temp1;
reg [15:0]	key_temp2;	
always@(posedge clk)
	begin
		key_temp1[15:0]	<=	key_in[15:0];
		key_temp2[15:0]	<=	key_temp1[15:0];
	end
wire	[15:0]	key_negedge;
assign	key_negedge[0]	=	key_temp2[0]&(!key_temp1[0]);
assign	key_negedge[1]	=	key_temp2[1]&(!key_temp1[1]);
assign	key_negedge[2]	=	key_temp2[2]&(!key_temp1[2]);
assign	key_negedge[3]	=	key_temp2[3]&(!key_temp1[3]);
assign	key_negedge[4]	=	key_temp2[4]&(!key_temp1[4]);
assign	key_negedge[5]	=	key_temp2[5]&(!key_temp1[5]);
assign	key_negedge[6]	=	key_temp2[6]&(!key_temp1[6]);
assign	key_negedge[7]	=	key_temp2[7]&(!key_temp1[7]);
assign	key_negedge[8]	=	key_temp2[8]&(!key_temp1[8]);
assign	key_negedge[9]	=	key_temp2[9]&(!key_temp1[9]);
assign	key_negedge[10]	=	key_temp2[10]&(!key_temp1[10]);
assign	key_negedge[11]	=	key_temp2[11]&(!key_temp1[11]);
assign	key_negedge[12]	=	key_temp2[12]&(!key_temp1[12]);
assign	key_negedge[13]	=	key_temp2[13]&(!key_temp1[13]);
assign	key_negedge[14]	=	key_temp2[14]&(!key_temp1[14]);
assign	key_negedge[15]	=	key_temp2[15]&(!key_temp1[15]);
reg	[2:0] key_state;
reg	[19:0]	delay_count_10ms;
reg keydata_int;
reg [15:0]	keydata;
always@(posedge clk	or	negedge	reset_n)
if(!reset_n)
	begin
		key_state	<=	0;
		delay_count_10ms	<=	0;
	end
else
	case(key_state)
	0	:	
	if(key_negedge[15:0]!=16'h0000)
		begin
			key_state	<=	1;
		end
	else
		key_state	<=	0;
	1	:
	begin
		delay_count_10ms	<=	delay_count_10ms	+	1'b1;
		if(delay_count_10ms	>=	20'h7A120)
			begin
				delay_count_10ms	<=	0;
				key_state	<=	2;
			end	
	end
	2	:if(key_in[15:0]!=16'hffff)
		begin
			keydata_int	<=	1'b1;
			keydata[15:0]	<=	key_in[15:0];
			key_state	<=	3;
		end
	3	:
		begin
			keydata_int	<=	1'b0;
			key_state	<=	0;
		end
	default	:	key_state	<=	0;
	endcase



/*
////////////////////////////////////////////////////////
//ÿ10msȡ16״̬
///////////////////////////////////////////////////////

always@(posedge clk_5ms or negedge reset_n)
	if(!reset_n)
		begin
			keydata_int	<=	1'b0;
			send_state	<=	1'b0;
		end
	else
	case(send_state)
	0	:
		begin
			keydata_int	<=	1'b1;
			keydata[15:0]	<=	key_temp2[15:0];
			send_state	<=	1'b1;
		end
	1	:
		begin
			keydata_int	<=	1'b0;
			send_state	<=	1'b0;
		end
	default	:	send_state	<=	1'b0;
	endcase
	*/
/////////////////////////////////////////////////////////////////
//Ͱݵģ
/////////////////////////////////////////////////////////////////
wire	bps_start;
wire	clk_bps;
my_uart_tx	u0(
	.clk(clk),					// 50MHzʱ
	.rst_n(reset_n),			//͵ƽλź
	.clk_bps(clk_bps),			// clk_bpsĸߵƽΪջ߷λм
	.rx_data(keydata[15:0]), 	//ݼĴ
	.rx_int(keydata_int),		//жź,յڼʼΪߵƽ,ڴ½
	.rs232_tx(rs232_tx_out),	// RS232ź
	.bps_start(bps_start)		//ջҪݣʱźλ		
	);
		
speed_select	u1(
	.clk(clk),					// 50MHzʱ
	.rst_n(reset_n),			//͵ƽλ
	.bps_start(bps_start),		//ջҪݣʱźλ	
	.clk_bps(clk_bps)			// clk_bpsĸߵƽΪջ߷λм
	);		

endmodule

